Option Compare Binary
Option Explicit On 
Option Strict On

Imports System
Imports System.Windows.Forms

''' <summary>
'''   Erweitert das ListBox-Steuerelement um die Mglichkeit, dieses zu
'''   sperren, sodass der Benutzer die Auswahl und den Inhalt nicht
'''   manipulieren kann.
''' </summary>
Public Class ExtendedListBox
    Inherits ListBox

    Private Const WM_KEYDOWN As Int32 = &H100
    Private Const WM_LBUTTONDOWN As Int32 = &H201
    Private Const WM_SETFOCUS As Int32 = &H7

    Private m_ReadOnly As Boolean

    Protected Overrides Sub WndProc(ByRef m As System.Windows.Forms.Message)
        If m_ReadOnly Then
            If m.Msg = WM_KEYDOWN OrElse m.Msg = WM_LBUTTONDOWN OrElse m.Msg = WM_SETFOCUS Then
                Return
            End If
        End If
        MyBase.WndProc(m)
    End Sub

    ''' <summary>
    '''   Gibt an oder zurck, ob der Inhalt und die Auwahl gesperrt sein soll.
    ''' <summary>
    ''' <value>Wert, der angibt, ob die Auswahl gendert werden kann.</value>
    Public Property [ReadOnly]() As Boolean
        Get
            Return m_ReadOnly
        End Get
        Set(ByVal Value As Boolean)
            m_ReadOnly = Value
        End Set
    End Property
End Class